export interface IColorRamp {
    type?: 'cat' | 'linear' | 'quantize' | 'custom';
    positions: number[];
    colors: string[];
}
export declare function isColor(str: any): boolean;
export declare function rgb2arr(str: string): number[];
export declare function decodePickingColor(color: Uint8Array): number;
export declare function encodePickingColor(featureIdx: number): [number, number, number];
export interface IImagedata {
    data: Uint8ClampedArray;
    width: number;
    height: number;
}
export declare function generateColorRamp(colorRamp: IColorRamp): ImageData | IImagedata;
export declare function generateLinearRamp(colorRamp: IColorRamp, domain: [number, number]): ImageData | IImagedata;
export declare function generateCatRamp(colorRamp: IColorRamp): ImageData | IImagedata;
export declare function generateQuantizeRamp(colorRamp: IColorRamp): ImageData | IImagedata;
export declare function generateCustomRamp(colorRamp: IColorRamp, domain: [number, number]): ImageData | IImagedata;
export declare function getDefaultDomain(rampColors: IColorRamp): number[];
