export type ELType = HTMLElement | SVGElement;
export type ElementType = HTMLElement | HTMLElement[] | DocumentFragment | Text | string;
export declare function getContainer(domId: string | HTMLDivElement): HTMLDivElement;
export declare function trim(str: string): string;
export declare function splitWords(str: string): string[];
export declare function create(tagName: string, className?: string, container?: HTMLElement): any;
export declare function remove(el: ELType | DocumentFragment): void;
export declare function addClass(el: ELType, name: string): void;
export declare function removeClass(el: ELType, name: string): void;
export declare function hasClass(el: ELType, name: string): boolean;
export declare function setClass(el: ELType, name: string): void;
export declare function getClass(el: ELType): any;
export declare function empty(el: ELType): void;
export declare function setTransform(el: ELType, value: string): void;
export declare function triggerResize(): void;
export declare function printCanvas(canvas: HTMLCanvasElement): void;
export declare function getViewPortScale(): number;
export declare const DPR: any;
export declare function addStyle(el: ELType, style: string): void;
export declare function getStyleList(style: string): string[];
export declare function removeStyle(el: ELType, style: string): void;
export declare function css2Style(obj: any): string;
export declare function getDiffRect(dom1Rect: any, dom2Rect: any): {
    left: number;
    top: number;
    right: number;
    bottom: number;
};
export declare function setChecked(el: ELType, value: boolean): void;
export declare function clearChildren(el: ELType): void;
export declare function setUnDraggable(el: ELType): void;
export declare function appendElementType(container: HTMLElement | DocumentFragment, children: ElementType): void;
