import { createWorker } from 'web-worker-helper';
export declare const WorkerSourceMap: {
    pointFill: ({ descriptors, features, enablePicking, shape2d, }: {
        descriptors: import("./interface").IVertexAttributeDescriptor[];
        features: import("./interface").IEncodeFeature[];
        enablePicking: boolean;
        shape2d: string[];
    }) => Promise<{
        descriptors: import("./interface").IVertexAttributeDescriptor[];
        featureLayout: {
            sizePerElement: number;
            elements: {
                featureIdx: number;
                vertices: number[];
                normals: number[];
                offset: number;
                indexes?: number[] | undefined;
            }[];
        };
        indices: number[];
    }>;
    line: ({ descriptors, features, enablePicking, iconMap, }: {
        descriptors: import("./interface").IVertexAttributeDescriptor[];
        features: import("./interface").IEncodeFeature[];
        enablePicking: boolean;
        iconMap: any;
    }) => Promise<{
        descriptors: import("./interface").IVertexAttributeDescriptor[];
        featureLayout: {
            sizePerElement: number;
            elements: {
                featureIdx: number;
                vertices: number[];
                normals: number[];
                offset: number;
                indexes?: number[] | undefined;
            }[];
        };
        indices: number[];
    }>;
    polygonFill: ({ descriptors, features, enablePicking, }: {
        descriptors: import("./interface").IVertexAttributeDescriptor[];
        features: import("./interface").IEncodeFeature[];
        enablePicking: boolean;
    }) => Promise<{
        descriptors: import("./interface").IVertexAttributeDescriptor[];
        featureLayout: {
            sizePerElement: number;
            elements: {
                featureIdx: number;
                vertices: number[];
                normals: number[];
                offset: number;
                indexes?: number[] | undefined;
            }[];
        };
        indices: number[];
    }>;
};
declare function worker({ workerType, data }: {
    workerType: string;
    data: any;
}): Promise<any>;
export { createWorker, worker };
