var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/lineAtOffset/arc.ts
var arc_exports = {};
__export(arc_exports, {
  arcLineAtOffset: () => arcLineAtOffset
});
module.exports = __toCommonJS(arc_exports);
var import_geo = require("../geo");
var import_map = require("../interface/map");
function arcLineAtOffset(source, target, offset, thetaOffset, mapVersion, segmentNumber = 30, autoFit) {
  let pointOffset = offset;
  if (autoFit) {
    pointOffset = Math.round(offset * (segmentNumber - 1)) / (segmentNumber - 1);
  }
  if (!thetaOffset) {
    return interpolate(source, target, pointOffset, 0.314, mapVersion);
  } else {
    return interpolate(source, target, pointOffset, thetaOffset, mapVersion);
  }
}
function bezier3(arr, t) {
  const ut = 1 - t;
  return (arr[0] * ut + arr[1] * t) * ut + (arr[1] * ut + arr[2] * t) * t;
}
function calDistance(p1, p2) {
  return Math.sqrt(Math.pow(p1[0] - p2[0], 2) + Math.pow(p1[1] - p2[1], 2));
}
function midPoint(source, target, thetaOffset) {
  const center = [target[0] - source[0], target[1] - source[1]];
  const r = calDistance(center, [0, 0]);
  const theta = Math.atan2(center[1], center[0]);
  const r2 = r / 2 / Math.cos(thetaOffset);
  const theta2 = theta + thetaOffset;
  const mid = [
    r2 * Math.cos(theta2) + source[0],
    r2 * Math.sin(theta2) + source[1]
  ];
  return mid;
}
function interpolate(source, target, offset, thetaOffset, mapVersion) {
  if (mapVersion === import_map.Version["GAODE2.x"]) {
    const sourceFlat = (0, import_geo.amap2Project)(source[0], source[1]);
    const targetFlat = (0, import_geo.amap2Project)(target[0], target[1]);
    const mid = midPoint(sourceFlat, targetFlat, thetaOffset);
    const x = [sourceFlat[0], mid[0], targetFlat[0]];
    const y = [sourceFlat[1], mid[1], targetFlat[1]];
    return [...(0, import_geo.amap2UnProject)(bezier3(x, offset), bezier3(y, offset)), 0];
  } else {
    const mid = midPoint(source, target, thetaOffset);
    const x = [source[0], mid[0], target[0]];
    const y = [source[1], mid[1], target[1]];
    return [bezier3(x, offset), bezier3(y, offset), 0];
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  arcLineAtOffset
});
