var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/tileset-manager/utils/tile-url.ts
var tile_url_exports = {};
__export(tile_url_exports, {
  expandUrl: () => expandUrl,
  getURLFromTemplate: () => getURLFromTemplate,
  getWMTSURLFromTemplate: () => getWMTSURLFromTemplate,
  isURLTemplate: () => isURLTemplate
});
module.exports = __toCommonJS(tile_url_exports);
var import_lonlat_tile = require("./lonlat-tile");
function isURLTemplate(s) {
  return /(?=.*{z})(?=.*{x})(?=.*({y}|{-y}))/.test(s);
}
function expandUrl(url) {
  const urls = [];
  let match = /\{([a-z])-([a-z])\}/.exec(url);
  if (match) {
    const startCharCode = match[1].charCodeAt(0);
    const stopCharCode = match[2].charCodeAt(0);
    let charCode;
    for (charCode = startCharCode; charCode <= stopCharCode; ++charCode) {
      urls.push(url.replace(match[0], String.fromCharCode(charCode)));
    }
    return urls;
  }
  match = /\{(\d+)-(\d+)\}/.exec(url);
  if (match) {
    const stop = parseInt(match[2], 10);
    for (let i = parseInt(match[1], 10); i <= stop; i++) {
      urls.push(url.replace(match[0], i.toString()));
    }
    return urls;
  }
  urls.push(url);
  return urls;
}
function getURLFromTemplate(template, properties) {
  if (!template || !template.length) {
    throw new Error("url is not allowed to be empty");
  }
  const { x, y, z } = properties;
  const urls = expandUrl(template);
  const index = Math.abs(x + y) % urls.length;
  const url = urls[index];
  return url.replace(/\{x\}/g, x.toString()).replace(/\{y\}/g, y.toString()).replace(/\{z\}/g, z.toString()).replace(/\{bbox\}/g, (0, import_lonlat_tile.tileToBounds)(x, y, z).join(",")).replace(/\{-y\}/g, (Math.pow(2, z) - y - 1).toString());
}
function getWMTSURLFromTemplate(template, properties) {
  const {
    x,
    y,
    z,
    layer,
    version = "1.0.0",
    style = "default",
    format,
    service = "WMTS",
    tileMatrixset
  } = properties;
  const url = `${template}&SERVICE=${service}&REQUEST=GetTile&VERSION=${version}&LAYER=${layer}&STYLE=${style}&TILEMATRIXSET=${tileMatrixset}&FORMAT=${format}&TILECOL=${x}&TILEROW=${y}&TILEMATRIX=${z}`;
  return url;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  expandUrl,
  getURLFromTemplate,
  getWMTSURLFromTemplate,
  isURLTemplate
});
